#ifndef _STUDENTCOLLECTION_H
#define _STUDENTCOLLECTION_H

#include <string>
#include <fstream>

#include "Student.h"
#include "CourseCollection.h"

using namespace std;

class StudentInCourseCollection;

class StudentCollection // version 1
{
friend void StudentInCourseCollection::add1StudentInCourse(
                              const StudentInCourse& aStdnInCrs );
friend void StudentInCourseCollection::delete1StudentInCourse(
                                        int aIdNum, string code );
public:
   StudentCollection();
   ~StudentCollection()  {  delete[] scArr;  }; // delete[] scIndex;  };
// getters
   size_t getNOfStudents() const {  return scNOfStudents;  }
   const Student* getArr() const {  return scArr;  }
   const StudentInCourseCollection* getPAllEnrollments() const
   {  return scPAllEnrollments;  }
// setters
   void setPAllEnrollments( StudentInCourseCollection* pEnrollments )
   {  scPAllEnrollments = pEnrollments;  }
// 1 Student
   bool find1Student( int aIdNum ) const
   {  return ( findNdx(aIdNum) >= 0 );  };
   const Student& get1Student( int aIdNum ) const;
   void add1Student( const Student& aStudent );
// other
   void save( ofstream& bout, SIndexEntry* index );
   void load( ifstream& bin );
   void swapArr( StudentCollection& rhs );
   void display( ostream& tout ) const;
   void checkWH( ostream& log, int maxWH ) const;
private:
   enum { scIncr = 30 }; //100 };
   Student*                   scArr;
   size_t                     scNOfStudents;
   size_t                     scReserved;
   StudentInCourseCollection* scPAllEnrollments;
   
   StudentCollection( const StudentCollection& rhs ) { };
   StudentCollection& operator=( const StudentCollection& rhs ) { };
   void erase1Student( int ndx );
   void insert1Student( const Student& aStudent );
   void add1Course( int aIdNum, const Course& aCourse );
   void delete1Course( int aIdNum, const Course& aCourse );
   int findNdx( int aIdNum ) const;
   void delete1Student( int aIdNum );
}; // StudentCollection

struct StudentCollectionXptn // version 1
{
   enum { allocFailed, notFound, noEnroll, enrollRef, negWH,
          fileNotOpen, cannotWrite, cannotRead };
   char methodName[100];
   int  errorCode;
   char errStrVal[100];
   char errIntVal;
   StudentCollectionXptn( const char* mn, int ec,
                          const char* sv="", int iv=0  )
      :  errorCode( ec ),  errIntVal( iv )
   {  strncpy( methodName, mn, 99 );  methodName[99] = '\0';
      strncpy( errStrVal, sv, 99 );  errStrVal[99] = '\0';  };
   StudentCollectionXptn( const char* mn, int ec, int iv )
      :  errorCode( ec ),  errIntVal( iv )
   {  strncpy( methodName, mn, 99 );  methodName[99] = '\0';  };
}; // StudentCollectionXptn

#endif // _STUDENTCOLLECTION_H
